



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>如何理解和熟练运用js中的call及apply？</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">如何理解和熟练运用js中的call及apply？</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-23 06:00:06 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<h1>改变this指向</h1>
<p>要先明白存在call和apply的原因，才能记得牢一点：</p>
<p>在javascript OOP中，我们经常会这样定义：</p>
<div>
<pre class="prettyprint linenums">function cat(){<br />
}<br />
cat.prototype={<br />
　　food:"fish",<br />
　　say: function(){<br />
　　　　alert("I love "+this.food);<br />
　　}<br />
}<br />
var blackCat = new cat;<br />
blackCat.say();</pre>
</div>
<div>
<div>但是如果我们有一个对象whiteDog = {food:"bone"},我们不想对它重新定义say方法，那么我们可以通过call或apply用blackCat的say方法：blackCat.say.call(whiteDog);</p>
<p>所以，可以看出call和apply是为了动态改变this而出现的，当一个object没有某个方法，但是其他的有，我们可以借助call或apply用其它对象的方法来操作。</p>
<p>用的比较多的，通过document.getElementsByTagName选择的dom 节点是一种类似array的array。它不能应用Array下的push,pop等方法。我们可以通过：<br />var domNodes =  Array.prototype.slice.call(document.getElementsByTagName("*"));<br />这样domNodes就可以应用Array下的所有方法了。</div>
<p>对arguments对象使用Array.prototype.slice()方法，可以将其转化为数组。</div>
<div>采用同样的办法，也可以将NodeList对象转化为数组。看下面的例子：</div>
<div>//在IE8及之前无效</div>
<div>var arryOfNodes = Array.prototype.slice.call(someNode.childNodes, 0);</div>
<div>在IE8及之前版本，将NodeList实现为一个COM对象，要想在IE中将NodeList转换为数组，必须手动枚举所有成员。</div>
<div>
<div>
<pre class="prettyprint linenums">function convertToArray(nodes) {<br />
    var array = null;<br />
    try {<br />
        array = Array.prototype.slice.call(nodes, 0);<br />
    } catch (ex) {<br />
        array = [];<br />
        for(var i=0, l=nodes.length; i &lt; l; i++){<br />
            array.push(nodes[i]);<br />
        }<br />
    }<br />
}
 </pre>
</div>
<div></p>
<div>call 和 apply 都是为了改变某个函数运行时的 context 即上下文而存在的，换句话说，就是为了改变函数体内部 this 的指向。因为 JavaScript 的函数存在「定义时上下文」和「运行时上下文」以及「上下文是可以改变的」这样的概念。</p>
<p>二者的作用完全一样，只是接受参数的方式不太一样。例如，有一个函数 func1 定义如下：</p>
<blockquote><p>var func1 = function(arg1, arg2) {};</p></blockquote>
<p>就可以通过 func1.call(this, arg1, arg2); 或者 func1.apply(this, [arg1, arg2]); 来调用。其中 this 是你想指定的上下文，他可以任何一个 JavaScript 对象(JavaScript 中一切皆对象)，call 需要把参数按顺序传递进去，而 apply 则是把参数放在数组里。</p>
<p>JavaScript 中，某个函数的参数数量是不固定的，因此要说适用条件的话，当你的参数是明确知道数量时，用 call，而不确定的时候，用 apply，然后把参数 push 进数组传递进去。当参数数量不确定时，函数内部也可以通过 arguments 这个数组来便利所有的参数。</p></div>
<div>&nbsp;</div>
<h1>Function.prototype.bind</h1>
<div>
<pre class="prettyprint linenums">var obj = {<br />
	name: "salody"<br />
};<br />
var func = function (a, b, c, d) {<br />
	console.log(this.name);   //输出salody<br />
	console.log([a, b, c, d]); //输出 [1, 2, 6, 7]<br />
}.bind(obj, 1, 2);

func(6, 7, 8, 9);   //实际上这里的8，9是多余出来的实参。 

Function.prototype.bind = function () {<br />
	var self = this,  //保存原函数<br />
		context = Array.prototype.shift.call(arguments), //需要绑定的this上下文<br />
		args = Array.prototype.slice.call(arguments);	//剩余的参数转化成数组<br />
	return function () {<br />
		return self.apply(context, [].concat.call(args, [].slice.call(arguments)));<br />
		//执行新的函数时，会把之前传入的context当做新函数的this<br />
		//并且组合两次分别传入的参数，作为新函数的参数<br />
	}<br />
}
</pre>
</div>
<p>　　</p>
</div>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/39r4ym80.html">asp&period;net mvc 验证码</a>
		</li>
						<li><a href="https://www.batexi.com/a/49gnwe87.html">safari cookie设置中文失败</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9j1oel9.html">spring boot 添加拦截器</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9p37p4q.html">php字符串处理函数大全</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qxrp7dq.html">【Git】标签管理</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k15kx69.html">获取https证书</a>
		</li>
						<li><a href="https://www.batexi.com/a/90v0eon8.html">一个类似于QQ语音聊天时的拖拽移动悬浮小球</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mn4y06q.html">PHP代码为什么不能直接保存HTML文件&mdash;&mdash;&amp;amp&semi;gt&semi;PHP生成静态页面教程</a>
		</li>
						<li><a href="https://www.batexi.com/a/93xe2gz9.html">MFC 控件初始化的过程</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1zgm049.html">javascript - 工作笔记 （事件绑定二）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwd70nl8.html">oracle rac 安装脚本</a>
		</li>
						<li><a href="https://www.batexi.com/a/8eyee1j9.html">C&plus;&plus;模板：二分图匹配</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mepj16q.html">1详细解析HTML基础结构</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv1o33jq.html">dojo API中英文缩写的意思</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pd53gk9.html">WeihanLi&period;Npoi</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2j1nww8.html">Python动态展现之一</a>
		</li>
						<li><a href="https://www.batexi.com/a/90rnyp39.html">UNIX环境高级编程--第一章 UNIX基础知识</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gjvk2e9.html">Web开发相关笔记 &num;04&num; WebSocket</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gp33k09.html">&lbrack;Vim&rsqb; Vim 常用基本操作</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1vp666q.html">【BZOJ】 3238&colon; &lbrack;Ahoi2013&rsqb;差异</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/xq4ng359.html">js 单例模式笔记</a>
			</li>
						<li><a href="https://www.batexi.com/a/49gd10e9.html">mysql 范式和反范式</a>
			</li>
						<li><a href="https://www.batexi.com/a/1q20drx9.html">A python script to check NE syncfail and get log from CIPS</a>
			</li>
						<li><a href="https://www.batexi.com/a/390emyoq.html">kafka使用getOffsetsBefore&lpar;&rpar;获取获取offset异常分析</a>
			</li>
						<li><a href="https://www.batexi.com/a/39r05r79.html">EasyUI-validatebox 自定义validType验证</a>
			</li>
						<li><a href="https://www.batexi.com/a/49gdp149.html">MySQL 数据备份与还原</a>
			</li>
						<li><a href="https://www.batexi.com/a/oqv0ejo8.html">Lambda表达式遍历集合</a>
			</li>
						<li><a href="https://www.batexi.com/a/rql5oo18.html">Eenterprise linux服务器分区</a>
			</li>
						<li><a href="https://www.batexi.com/a/5qxel4d8.html">easyui combobox 左匹配模糊查询</a>
			</li>
						<li><a href="https://www.batexi.com/a/o8k5ml78.html">Docker容器是否可以改变世界？</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
